#!/etc/opt/openit/perl

# Applies the following updates for licenseevents-host-usage.conf:
# classifications object values for Report filter - var8 and var9 values change to 'undef'
# Remove Duplicate:usergroups filter process and definition

my $filter = "/var/opt/openit/etc/filtrator/licenseevents-host-usage.conf";
my @lines = _read_file( $filter );

my $ind = 0;


# Remove Concurrent:feature.keytype object 
$ind = locateLine($ind , "filter-defs" , \@lines );
$ind = locateLine($ind , "Concurrent.feature" , \@lines );
$ind = locateLine($ind , "keytype.String.=" , \@lines );
if ( $ind != 0 )
{
	splice @lines, $ind, 1;
	print(" -- Removing keytype\n");
}


# Remove used_licenses in Concurrent:feature.compare
$ind = 0;
$ind = locateLine($ind , "filter-defs" , \@lines );
$ind = locateLine($ind , "Concurrent.feature" , \@lines );
$ind = locateLine($ind , "compare.String.=" , \@lines );
if ( $ind != 0 )
{
	@lines[$ind] =~ s/used_licenses\s*,//;
}

_save_filter($filter, @lines);
print( "-- Done updating Host license use Licenseevents.\n");
exit( 0 ); 


sub _save_filter
{
	my ( $cfg, @lines ) = @_; 
	
	my $old = "$cfg.pre_2125";
	my $new = "$cfg.new";
	
	open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close(OUT);

	if( ! rename($cfg, $old)) {
		die "Error: Unable to previous config to '$old'!\n";
	}

	if( ! rename($new, $cfg)) {
		die "Error: Unable to rename new config to '$cfg'!\n";
	}
}


sub locateLine{
	my ( $start , $find , $lines_ref ) = (@_);
	
	my ( $index )= grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	
	return $index;
}

sub _read_file
{
	my ($cfg) = @_;
	open(IN, "$cfg") || die "Error: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close(IN);
	return @lines;
}
