#!/etc/opt/openit/perl

# Applies the following updates for licenseevents-total-usage.conf:
# classifications object values for Report filter - var8 and var9 values change to 'undef'
# Remove Duplicate:usergroups filter process and definition
# Adds the Mapping:available-licenses filter after CalcSum:license-usage-all

my $filter = "/var/opt/openit/etc/filtrator/licenseevents-total-usage.conf";
my @lines = _read_file( $filter );

my $ind = 0;

$ind = locateLine($ind , "filter-defs" , \@lines );
$ind = locateLine($ind , "Concurrent.feature" , \@lines );
$ind = locateLine($ind , "compare.String.=" , \@lines );

if ( $ind != 0 )
{
	@lines[$ind] =~ s/used_licenses\s*,//;
}

$ind = 0;

$ind = locateLine( $ind , "filter-process" , \@lines );
$ind = locateLine( $ind , "CalcSum.license-usage-all" , \@lines );
$ind++;

if( $ind != 0 )
{
	@lines[$ind] =~ s/{/{\n\t\t\t\t\t\t\t\t\t\tMapping\:available-licenses()=""\n\t\t\t\t\t\t\t\t\t\t{\n/;
	$ind = locateLine( $ind , "^\t\t\t\t\t\t\t\t}" , \@lines );
	@lines[$ind] =~ s/}/}\n\t\t\t\t\t\t\t\t}\n/;
}

my @avail_license_def = (
	"\t\tMapping:available-licenses()=\"\"\n",
	"\t\t{\n",
	"\t\t\tinactive(Bool)=\"false\"{}\n",
	"\t\t\tfilter(String)=\"Mapping\"{}\n",
	"\t\t\tmap-file(FileName)=\"\${OpeniT.directories.conf}available-licenses.map\"{}\n",
	"\t\t\tsource(String)=\"var4\"{}\n",
	"\t\t\ttarget(String)=\"licenses\"{}\n",
	"\t\t\tset-value(String)=\"#1:var4=\$feature . \'\\\\\' . \$product\"{}\n",
	"\t\t}\n"
);

$ind = locateLine( $ind , "filter-defs" , \@lines );
$ind = locateLine( $ind , "CalcSum.license-usage-all" , \@lines );
$ind = locateLine( $ind , "^\t\t}\n" , \@lines );

if( $ind != 0 )
{
	@lines[$ind] =~ s/\t\t}\n/\t\t}\n@avail_license_def/;
}


_save_filter($filter, @lines);
print( "-- Done updating Total license use Licenseevents.\n");
exit( 0 ); 


sub _save_filter
{
	my ( $cfg, @lines ) = @_; 
	
	my $old = "$cfg.pre_2125";
	my $new = "$cfg.new";
	
	open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close(OUT);

	if( ! rename($cfg, $old)) {
		die "Error: Unable to rename previous config to '$old'!\n";
	}

	if( ! rename($new, $cfg)) {
		die "Error: Unable to rename new config to '$cfg'!\n";
	}
}


sub locateLine{
	my ( $start , $find , $lines_ref ) = (@_);
	
	my ( $index )= grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	
	return $index;
}

sub _read_file
{
	my ($cfg) = @_;
	open(IN, "$cfg") || die "Error: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close(IN);
	return @lines;
}
