#!/etc/opt/openit/perl

# Applies the following updates for acc_types:
# Sets the proper classification entries for License^logfile^events^v2
# Product, Package, Feature, Feature^version, Event^type, Event^subtype, User, Host^name, Details

my $old_acc_types = "/var/opt/openit/etc/acc_types";
my @new_acc_types_lines;

my $logfile_events_line_found = 0;

open( IN, $old_acc_types ) || die "ERROR: Unable to read acc_types!\n";

foreach my $line ( <IN> ) {
	if( $line =~ /License\^logfile\^events\^v2/ ) {
		$logfile_events_line_found = 1;
	}

	if( $logfile_events_line_found and $line =~ /User/ ) {
		$logfile_events_line_found = 0;
	}

	if( $logfile_events_line_found and $line =~ /Used\^licenses/ ) {
		$logfile_events_line_found = 0;
		next;
	}

	push @new_acc_types_lines, $line;
}

close( IN );

rename( $old_acc_types, "$old_acc_types.pre_2125" ) || die "ERROR: Unable to rename old acc_types file!\n";

open( OUT, ">$old_acc_types" ) || die "ERROR: Unable to write new acc_types!\n";
print OUT @new_acc_types_lines;
close( OUT );

exit( 0 ); 
