#!/etc/opt/openit/perl

# Applies the following updates for classvar_mapping_config:
# Sets the proper entries for License^logfile^events^v2

my $file = "/var/opt/openit/etc/classvar_mapping_config";
my @lines = _process_file( $file );

_save_file( $file, @lines );
print( "-- Done updating classvar_mapping_config.\n" );
exit( 0 );



sub _process_file {
	my ( $file ) = @_;
	open( IN, $file ) || die "ERROR: Unable to read cfg '$file'!\n";
	
	my @lines;
	my $entry_found = 0;
	my $line_modified = 0;

	foreach my $line ( <IN> ) {
		if( $entry_found and ! $line_modified ) {
			$line = "    (User, Host^name, Details),\n";
			$line_modified = 1;
		}

		if( $line =~ /License\^logfile\^events\^v2/ ) {
			$entry_found = 1;
		}
		
		push @lines, $line;
	}

	close( IN );

	return @lines;
}

sub _save_file {
	my ( $cfg, @lines ) = @_;
	my $old = "$cfg.pre_2125";
	rename( $cfg, $old ) || die "ERROR: Unable to rename previous config to '$old'!\n";
	open( OUT, ">$cfg" );
	print OUT @lines;
	close( OUT );
}
