#!/etc/opt/openit/perl

# Applies the following updates to daft.conf:
# Adds this entry (licenseevents-denied $BEG $END P1D) in the licenseevents field of the archiver section if it is not yet existing
# Adds this entry (LogParserFekete.license.events) in the licenseevents field of the datagroup-generation section if it is not yet existing

my $filter = "/var/opt/openit/etc/daft.conf";
my @lines = _read_file( $filter );

my $index = 0;

# Updating licenseevents field in archiver section here
$index = locateLine( $index, "archiver", \@lines );
$index = locateLine( $index, "filtrate", \@lines );
$index = locateLine( $index, "licenseevents", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /licenseevents-denied/ ) {
		@lines[$index] =~ s/"\{\}/,licenseevents-denied \$BEG \$END P1D\"\{\}/;
	}
}

# Updating licenseevents field in datagroup-generation section here
$index = locateLine( $index, "datagroup-generation", \@lines );
$index = locateLine( $index, "licenseevents", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /LogParserFekete\.license\.events/ ) {
		@lines[$index] =~ s/="/="LogParserFekete.license.events,/;
	}
}

_save_filter( $filter, @lines );
print( "-- Done updating daft.conf.\n" );
exit( 0 );



sub _read_file {
	my ( $cfg ) = @_;
	open( IN, $cfg ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locateLine {
	my ( $start, $find, $lines_ref ) = ( @_ );
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub _save_filter {
	my ( $cfg, @lines ) = @_;
	my $old = "$cfg.pre_2125";

	rename( $cfg, $old ) || die "ERROR: Unable to rename previous config to '$old'!\n";

	open( OUT, ">$cfg" );
	print OUT @lines;
	close( OUT );
}
