#!/etc/opt/openit/perl

# Applies the following update for individual-license-use-licenseevents.conf:
# zero-count in Concurrent:feature filter will be set to false

my $filter = "/var/opt/openit/etc/filtrator/individual-license-use-licenseevents.conf";
my @lines = _read_file( $filter );

my $index = 0;

$index = locateLine( $index, "filter-defs", \@lines );
$index = locateLine( $index, "Concurrent\:feature", \@lines );
$index = locateLine( $index, "zero\-count", \@lines );

if( $index != 0 ) {
	@lines[$index] =~ s/true/false/;
}

_save_filter( $filter, @lines );
print( "-- Done filtering Individual license use licenseevents.\n" );
exit( 0 );



sub _read_file {
	my ( $cfg ) = @_;
	open( IN, $cfg ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locateLine {
	my ( $start, $find, $lines_ref ) = ( @_ );
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub _save_filter {
	my ( $cfg, @lines ) = @_;
	my $old = "$cfg.pre_2125";

	rename( $cfg, $old ) || die "ERROR: Unable to rename previous config to '$old'!\n";

	open( OUT, ">$cfg" );
	print OUT @lines;
	close( OUT );
}
