#!/etc/opt/openit/perl


my $old_licenseevents_conf = "/var/opt/openit/etc/filtrator/licenseevents-log-v2.conf";

open( IN, $old_licenseevents_conf ) || die "ERROR: Unable to open licenseevents-log-v2.conf!\n";

my @new_licenseevents_lines;
my $filter_process_scope = 0;
my $filter_defs_scope = 0;

my $remove_empty_features_found = 0;
my $mapping_status_process_inserted = 0;
my $mapping_status_definition_inserted = 0;
my $mapping_status_close_brace_inserted = 0; 

foreach my $line ( <IN> ) {
	# Start and end of filter-process scope
	if( $line =~ /filter-process/ ) {
		$filter_process_scope = 1;
	}
	if( $line =~ /filter-defs/ ) {
		$filter_process_scope = 0;
		$filter_defs_scope = 1;
	}

	# START inserting Mapping:status process
	# remove-empty-features process line found
	if( $filter_process_scope and $line =~ /Threshold\:remove-empty-features/ ) {
		$remove_empty_features_found = 1;
	}

	if( $filter_process_scope and $remove_empty_features_found and $line =~ /Mapping\:status/ ) {
		print "Conf file already updated. Aborting script.\n";
		exit( 0 );
	}

	# Insert Mapping:status process
	if( ! $mapping_status_process_inserted and $remove_empty_features_found and $line =~ /\{/ ) {
		push @new_licenseevents_lines, $line;
		push @new_licenseevents_lines, "\t\t\t\t\t\tMapping\:status()=\"\"\n";
		push @new_licenseevents_lines, "\t\t\t\t\t\t\{\n";
		$mapping_status_process_inserted = 1;
		next;
	}

	# Try to properly indent filter process
	if( $mapping_status_process_inserted and $filter_process_scope ) {
		push @new_licenseevents_lines, "\t";
	}

	# Insert closing brace for Mapping:status
	if( ! $mapping_status_close_brace_inserted and $line =~ /filter-defs/ ) {
		push @new_licenseevents_lines, "\t\}\n";
		$mapping_status_close_brace_inserted = 1;
	}
	# END inserting Mapping:status process

	# START inserting Mapping:status definition
	if( $filter_defs_scope and $line =~ /\{/ and ! $mapping_status_definition_inserted ) {
		push @new_licenseevents_lines, $line;
		push @new_licenseevents_lines, "\t\tMapping\:status()=\"\"\n";
		push @new_licenseevents_lines, "\t\t\{\n";
		push @new_licenseevents_lines, "\t\t\tinactive(Bool)=\"false\"\{\}\n";
		push @new_licenseevents_lines, "\t\t\tfilter(String)=\"Mapping\"\{\}\n";
		push @new_licenseevents_lines, "\t\t\tsimple-map(String)=\"'1'='DAEMON START','2'='DAEMON STOP','3'='CHECK OUT','4'='CHECK IN','6'='TIMED OUT','7'='FEATURE INCREMENT','8'='USAGE TRACE ON','9'='USAGE TRACE OFF','10'='USAGE NOT FOUND','14'='FALSE USAGE','20'='DENIED','21'='UNSUPPORTED','22'='QUEUED'\"\{\}\n";
		push @new_licenseevents_lines, "\t\t\tsource(String)=\"status\"\{\}\n";
		push @new_licenseevents_lines, "\t\t\ttarget(String)=\"event_type\"\{\}\n";
		push @new_licenseevents_lines, "\t\t\}\n";
		$mapping_status_definition_inserted = 1;
		next;
	}
	# END inserting Mapping:status definition

	push @new_licenseevents_lines, $line;
}

close( IN );

rename( $old_licenseevents_conf, "$old_licenseevents_conf.pre_2125" ) || die "ERROR: Unable to rename old licenseevents-log-v2.conf file!\n";

open( OUT, ">$old_licenseevents_conf" ) || die "ERROR: Unable to write new licenseevents-log-v2.conf file!\n";
print OUT @new_licenseevents_lines;
close( OUT );

exit( 0 );
