#!/etc/opt/openit/perl

# Adds the feature-rename-via-software-id mapping configuration in licensestatusconverter.conf

my $lsc_config = "/var/opt/openit/etc/licensestatusconverter.conf";

if( ! -e $lsc_config ) {
	print "Could not find $lsc_config , exiting script...\n";
	exit;
}

open( FILE, $lsc_config );
my @lines = <FILE>;
close( FILE );

# Check if config file has already been updated
if( grep { /feature-rename-via-software-id/ } @lines ) {
	print "$lsc_config already updated. Exiting script...\n";
	exit;
}

my @new_mapping = (
	"\t\tfeature-rename-via-software-id()=\"\"\n",
	"\t\t{\n",
	"\t\t\tfilter(String)=\"Mapping\"{}\n",
	"\t\t\tmap-file(FileName)=\"\${OpeniT.directories.conf}softwareid-to-feature_name.map\"{}\n",
	"\t\t\tmatch-string(String)=\"feature\\\\daemon\\\\type\\\\product\"{}\n",
	"\t\t\ttarget(String)=\"feature\"{}\n",
	"\t\t\tactive(Bool)=\"true\"{}\n",
	"\t\t}\n"
);
my $index = 0;

# Insert new mapping definition here
$index++ while( $lines[$index] !~ /feature-mapping/ );
$index++ while( $lines[$index] !~ /\t\t}/ );
$index++;
splice @lines, $index, 0, @new_mapping;

# Backup licensestatusconverter.conf
print "Creating backup file for $lsc_config ...\n";
rename( $lsc_config, $lsc_config . ".old_2125" );

# Write new licensestatusconverter.conf file
open( OUT, ">$lsc_config" );
print OUT @lines;
close( OUT );
print "$lsc_config successfully updated!\n";
