#!/etc/opt/openit/perl

open( IN, "/var/opt/openit/inst/package/common.info" ) || die "ERROR: Unable to fetch version from common.info!\n";
 
foreach my $line ( <IN> ) {
	if( $line =~ /VERSION/ ) {
		my @version_line = split / /, $line;
		if( $version_line[1] != "6.5.0.22" ) {
			print "Version is not 6.5.0.22; rawarchiveregenerator.conf does not exist.\n";
			exit( 0 );
		}
	}
}

close( IN );

my @content = <IN>;

if( grep {/fekete/} @content ) {
	print "Conf file already updated. Aborting script.\n";
	exit( 0 );
}

my $old_conf_file = "/var/opt/openit/etc/rawarchiveregenerator.conf";
my @new_conf_lines;

open( IN, $old_conf_file ) || die "ERROR: Unable to read rawarchiveregenerator.conf!\n";

my $raw_line_found = 0;
my $mapping_line_found = 0;
my $fekete_line_inserted = 0;

foreach my $line ( <IN> ) {
	if( $line =~ /rawarchiveregenerator()/ ) {
		$raw_line_found = 1;
	}

	if( $raw_line_found and $line =~ /mapping/ ) {
		$mapping_line_found = 1;
	}

	if( $raw_line_found and $mapping_line_found and $line =~ /autodesk/ and ! $fekete_line_inserted ) {
		push @new_conf_lines, $line;
		push @new_conf_lines, "\t\tfekete(String)=\"LogFileCollector.license.fekete\"\{\}\n";
		$fekete_line_inserted = 1;
		next;
	}

	push @new_conf_lines, $line;
}

close( IN );

rename( $old_conf_file, "/var/opt/openit/etc/rawarchiveregenerator.conf.old_2105" ) || die "ERROR: Unable to rename old rawarchiveregenerator.conf file!\n";

open( OUT, ">/var/opt/openit/etc/rawarchiveregenerator.conf" ) || die "ERROR: Unable to write new rawarchiveregenerator.conf!\n";
print OUT @new_conf_lines;
close( OUT );

exit( 0 );
